/* generated by gtkcooker (http://sed.free.fr/gtkcooker) */

#include "gui.h"

#include "list.h"
#include "symlist.h"



#define min(a,b) ((a) < (b) ? (a) : (b))

int *alpha_order;
int *calls_order;
int *self_order;
int *cumul1_order;
int *cumul2_order;

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void reset_shown(void *unused, int *x)
{
  *x = 0;
}

/* pretty printing code from Enrico Segre (currently at
 * the Weizmann Institute if you look for him) (he prefers
 * not to have his email in there to fight against spam)
 */
#define FORMATMAIN "%-*s # %*d # %*.3f | %*.3f | %*.3f"
#define FORMATCALLS "%-*s # %*d/%*d # %*.3f | %*.3f | %*.3f"
#define FORMATEXPL "%s # %d calls # self=%.3f | cumul1=%.3f | cumul2=%.3f"
#define FORMATCALLED FORMATMAIN

/* some ugly globals! (not from Enrico, don't blame him) */
static int pretty_print_column_width; /* 0 means no pretty print */
static int width_maxname;
static int width_maxcalls;
static int width_maxtself;
static int width_maxt1;
static int width_maxt2;

static char *dump_symbol(sym_info *cur, char *name)
{
  static char buf[4096];
  if (pretty_print_column_width)
    snprintf(buf, 4095, FORMATEXPL,
             name,
             cur->count,
             cur->internal_time / 100,
             cur->cumuled_time_1 / 100,
             cur->cumuled_time_2 / 100);
  else
    snprintf(buf, 4095, "%s [%d] (%f | C1 %f | C2 %f)",
             name,
             cur->count,
             cur->internal_time / 100,
             cur->cumuled_time_1 / 100,
             cur->cumuled_time_2 / 100);
  return buf;
}

static void toggle_help_callback(void *unused, gui *sg)
{
  if (sg->help_window_shown)
    gtk_widget_hide_all(sg->help_window);
  else
    gtk_widget_show_all(sg->help_window);
  sg->help_window_shown = 1 - sg->help_window_shown;
}

static gboolean delete_help_callback(void *u1, void *u2, gui *sg)
{
  toggle_help_callback(0, sg);
  return TRUE;
}

static GdkGC *blue_gc;

static int intwidth(int n)
{
  char buf[32];
  sprintf(buf,"%d",n);
  return strlen(buf);
}

static int floatwidth(double f)
{
  char buf[32];
  sprintf(buf,"%.3f",f);
  return strlen(buf);
}



static void _2(GtkButton *_widget, about *this)
{
  {
    *(this->shown) = 0;
    gtk_widget_destroy(this->win);
  }
}

/* returns -1 on error, 0 if everything is fine */
int init_about(about *this, int *shown, void *dady)
{
  GtkWidget *_0;
  GtkWidget *_1;
  GtkWidget *_3;
  GtkWidget *_4;

  {
    this->shown = shown;
  }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width(GTK_CONTAINER(this->win), 5);
  if (dady)
    gtk_window_set_transient_for(GTK_WINDOW(this->win), GTK_WINDOW(dady));
  gtk_window_set_position(GTK_WINDOW(this->win), GTK_WIN_POS_CENTER_ON_PARENT);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 10);
  this->l = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->l), "<b>XGprof</b> - faster than gprof (and what a nice GUI)\nhttp://sed.free.fr/xgprof\n\nIn case of bugs or troubles, contact the author.\nsed@free.fr\n\nEnrico Segre contributed with the pretty printing code.\n\nThis shit is public domain stuff.");
  gtk_misc_set_padding(GTK_MISC(this->l), 15, 15);
  this->okb = gtk_button_new();
  gtk_widget_set_size_request(this->okb, 80, -1);
  _1 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_1), "OK");
  this->space = gtk_vbox_new(FALSE, 0);
  _3 = gtk_hbox_new(FALSE, 0);
  _4 = gtk_hbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER(this->win), _0);
  gtk_box_pack_start(GTK_BOX(_0), _3, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_0), _4, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(this->okb), _1);
  gtk_box_pack_start(GTK_BOX(_3), this->l, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_4), this->space, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_4), this->okb, FALSE, FALSE, 0);


  this->okb_clicked = g_signal_connect(this->okb, "clicked", G_CALLBACK(_2), this);

  {
    g_signal_connect(this->win, "destroy", G_CALLBACK(reset_shown), shown);
    gtk_label_set_selectable(GTK_LABEL(this->l), TRUE);
    gtk_widget_grab_focus(this->okb);
  }

  return 0;
}

static void _13(GtkButton *_widget, gui *this)
{
  {
    this->order = alpha_order;
    gtk_widget_queue_draw(this->fun_list);
  }
}

static void _15(GtkButton *_widget, gui *this)
{
  {
    this->order = calls_order;
    gtk_widget_queue_draw(this->fun_list);
  }
}

static void _17(GtkButton *_widget, gui *this)
{
  {
    this->order = self_order;
    gtk_widget_queue_draw(this->fun_list);
  }
}

static void _19(GtkButton *_widget, gui *this)
{
  {
    this->order = cumul1_order;
    gtk_widget_queue_draw(this->fun_list);
  }
}

static void _21(GtkButton *_widget, gui *this)
{
  {
    this->order = cumul2_order;
    gtk_widget_queue_draw(this->fun_list);
  }
}

static void _23(GtkButton *_widget, gui *this)
{
  {gtk_main_quit();}
}

static void _25(GtkButton *_widget, gui *this)
{
  {
    if (this->about_displayed) return;
    this->about_displayed = 1;
    init_about(&this->about, &this->about_displayed, this->win);
    gtk_widget_show_all(this->about.win);
  }
}

static void _27(GtkButton *_widget, gui *this)
{
  {
    gtk_widget_show_all(this->help_window);
    this->help_window_shown = 1;
  }
}

static void _29(GtkButton *_widget, gui *this)
{
  {
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(_widget)))
      pretty_print_column_width = this->pretty_print_width;
    else
      pretty_print_column_width = 0;
    this->list_width = 1;
    this->call_width = 1;
    this->called_width = 1;
    gtk_widget_queue_draw(this->fun_list);
    gtk_widget_queue_draw(this->fun_call);
    gtk_widget_queue_draw(this->fun_called);
    if (this->cur)
      gtk_entry_set_text(GTK_ENTRY(this->fun_current),
                         dump_symbol(this->cur, this->name));
  }
}

static void _30(GtkEntry *_widget, gui *this)
{
  {
    char t[64];
    this->pretty_print_width = atoi(gtk_entry_get_text(GTK_ENTRY(_widget)));
    if (this->pretty_print_width > 4096) this->pretty_print_width = 4096;
    if (this->pretty_print_width < 1) this->pretty_print_width = 1;
    sprintf(t, "%d", this->pretty_print_width);
    gtk_entry_set_text(GTK_ENTRY(_widget), t);
    if (pretty_print_column_width)
      pretty_print_column_width = this->pretty_print_width;
    gtk_widget_queue_draw(this->fun_list);
    gtk_widget_queue_draw(this->fun_call);
    gtk_widget_queue_draw(this->fun_called);
    if (this->cur)
      gtk_entry_set_text(GTK_ENTRY(this->fun_current),
                         dump_symbol(this->cur, this->name));
  }
}

static gboolean _6(GtkWidget *_widget, GdkEventExpose *_event, gui *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  {
    int start = y/this->font_height;
    int end = (y+height+this->font_height-1)/this->font_height;
    int i;
    char buf[4096];
    if (end > nb_unique_symbols()-1) end = nb_unique_symbols()-1;
    for (i=start; i<=end; i++) {
      sym_info *cur = symbols + this->order[i];
      char *name = symbol_name(this->order[i]);
      int w;
      if (pretty_print_column_width)
        snprintf(buf, 4095, FORMATMAIN,
                 min(pretty_print_column_width, width_maxname), name,
                 width_maxcalls, cur->count,
                 width_maxtself, cur->internal_time / 100,
                 width_maxt1, cur->cumuled_time_1 / 100,
                 width_maxt2, cur->cumuled_time_2 / 100);
      else
        snprintf(buf, 4095, "%s [%d] (%f | C1 %f | C2 %f)",
                 name,
                 cur->count,
                 cur->internal_time / 100,
                 cur->cumuled_time_1 / 100,
                 cur->cumuled_time_2 / 100);

      w = gdk_string_width(this->font, buf);
      if (w > this->list_width) {
        this->list_width = w;
        gtk_widget_set_size_request(this->fun_list, this->list_width + 10,
                                    this->font_height * nb_unique_symbols());
      }
      if (i == this->line_fun) {
        gdk_draw_rectangle(this->fun_list->window, blue_gc, TRUE,
                  0, i*this->font_height,
                  32767, this->font_height);
      }
      gdk_draw_string(this->fun_list->window,
                      this->font,
                      this->fun_list->style->
                          fg_gc[GTK_WIDGET_STATE (this->fun_list)],
                      5, i*this->font_height+this->font_ascent,
                      buf);
    }
  }
  return TRUE;
}

static gboolean _7(GtkWidget *_widget, GdkEvent *_event, gui *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    int line;
    sym_info *cur;
    char *name;
    if (type == GDK_MOTION_NOTIFY) {
      line = y / this->font_height;
      if (line < 0 || line >= nb_unique_symbols()) return TRUE;
      if (this->line_fun == line) return TRUE;
      this->line_fun = line;
      gtk_widget_queue_draw(this->fun_list);
      return TRUE;
    }
    if (type != GDK_BUTTON_PRESS) return TRUE;
    line = y / this->font_height;
    if (line < 0 || line >= nb_unique_symbols()) return TRUE;
    cur = symbols + this->order[line];
    name = symbol_name(this->order[line]);
    gtk_entry_set_text(GTK_ENTRY(this->fun_current), dump_symbol(cur, name));
    this->cur = cur;
    this->name = name;

    this->calls = &cur->call;
    this->called = &cur->called_by;
    this->call_width = 1;
    this->called_width = 1;

    gtk_widget_set_size_request(this->fun_call, 200,
                                this->font_height * list_size(this->calls)/2);
    gtk_widget_set_size_request(this->fun_called, 200,
                                this->font_height * list_size(this->called)/2);
    gtk_widget_queue_draw(this->fun_call);
    gtk_widget_queue_draw(this->fun_called);
  }
  return TRUE;
}

static gboolean _8(GtkWidget *_widget, GdkEventExpose *_event, gui *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  {
    int start;
    int end;
    int i;
    char buf[4096];
    int nb_elems;

    if (this->calls == NULL) return TRUE;

    nb_elems = list_size(this->calls) / 2;
    start = y/this->font_height;
    end = (y+height+this->font_height-1)/this->font_height;
    if (end > nb_elems-1) end = nb_elems-1;
    for (i=start; i<=end; i++) {
      sym_info *cur = symbols + list_get(this->calls, i*2);
      char *name = symbol_name(list_get(this->calls, i*2));
      int nb_calls = list_get(this->calls, i*2+1);
      int w;
      if (pretty_print_column_width)
        snprintf(buf, 4095, FORMATCALLS,
                 min(pretty_print_column_width, width_maxname), name,
                 width_maxcalls, nb_calls,
                 width_maxcalls, cur->count,
                 width_maxtself, cur->internal_time / 100,
                 width_maxt1, cur->cumuled_time_1 / 100,
                 width_maxt2, cur->cumuled_time_2 / 100);
      else
        snprintf(buf, 4095, "%s [%d] {%d} (%f | C1 %f | C2 %f)",
                 name,
                 nb_calls,
                 cur->count,
                 cur->internal_time / 100,
                 cur->cumuled_time_1 / 100,
                 cur->cumuled_time_2 / 100);
      w = gdk_string_width(this->font, buf);
      if (w > this->call_width) {
        this->call_width = w;
        gtk_widget_set_size_request(this->fun_call, this->call_width + 10,
                                    this->font_height *
                                        list_size(this->calls)/2);
      }
      if (i == this->line_call) {
        gdk_draw_rectangle(this->fun_call->window, blue_gc, TRUE,
                  0, i*this->font_height,
                  32767, this->font_height);
      }
      gdk_draw_string(this->fun_call->window,
                      this->font,
                      this->fun_call->style->
                          fg_gc[GTK_WIDGET_STATE (this->fun_call)],
                      5, i*this->font_height+this->font_ascent,
                      buf);
    }
  }
  return TRUE;
}

static gboolean _9(GtkWidget *_widget, GdkEvent *_event, gui *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    int line;
    sym_info *cur;
    char *name;
    if (this->calls == NULL) return TRUE;
    if (type == GDK_MOTION_NOTIFY) {
      line = y / this->font_height;
      if (line < 0 || line >= list_size(this->calls)/2) return TRUE;
      if (this->line_call == line) return TRUE;
      this->line_call = line;
      gtk_widget_queue_draw(this->fun_call);
      return TRUE;
    }
    if (type != GDK_BUTTON_PRESS) return TRUE;
    line = y / this->font_height;
    if (line < 0 || line >= list_size(this->calls)/2) return TRUE;
    cur = symbols + list_get(this->calls, line*2);
    name = symbol_name(list_get(this->calls, line*2));
    gtk_entry_set_text(GTK_ENTRY(this->fun_current), dump_symbol(cur, name));
    this->cur = cur;
    this->name = name;

    this->calls = &cur->call;
    this->called = &cur->called_by;
    this->call_width = 1;
    this->called_width = 1;

    gtk_widget_set_size_request(this->fun_call, 200,
                                this->font_height * list_size(this->calls)/2);
    gtk_widget_set_size_request(this->fun_called, 200,
                                this->font_height * list_size(this->called)/2);
    gtk_widget_queue_draw(this->fun_call);
    gtk_widget_queue_draw(this->fun_called);
  }
  return TRUE;
}

static gboolean _10(GtkWidget *_widget, GdkEventExpose *_event, gui *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  {
    int start;
    int end;
    int i;
    char buf[4096];
    int nb_elems;

    if (this->called == NULL) return TRUE;

    nb_elems = list_size(this->called) / 2;
    start = y/this->font_height;
    end = (y+height+this->font_height-1)/this->font_height;
    if (end > nb_elems-1) end = nb_elems-1;
    for (i=start; i<=end; i++) {
      sym_info *cur = symbols + list_get(this->called, i*2);
      char *name = symbol_name(list_get(this->called, i*2));
      int nb_calls = list_get(this->called, i*2+1);
      int w;
      if (pretty_print_column_width)
        snprintf(buf, 4095, FORMATCALLED,
                 min(pretty_print_column_width, width_maxname), name,
                 width_maxcalls, nb_calls,
                 width_maxtself, cur->internal_time / 100,
                 width_maxt1, cur->cumuled_time_1 / 100,
                 width_maxt2, cur->cumuled_time_2 / 100);
      else
        snprintf(buf, 4095, "%s [%d] (%f | C1 %f | C2 %f)",
                 name,
                 nb_calls,
                 cur->internal_time / 100,
                 cur->cumuled_time_1 / 100,
                 cur->cumuled_time_2 / 100);
      w = gdk_string_width(this->font, buf);
      if (w > this->called_width) {
        this->called_width = w;
        gtk_widget_set_size_request(this->fun_called, this->called_width + 10,
                                    this->font_height *
                                        list_size(this->called)/2);
      }
      if (i == this->line_called) {
        gdk_draw_rectangle(this->fun_called->window, blue_gc, TRUE,
                  0, i*this->font_height,
                  32767, this->font_height);
      }
      gdk_draw_string(this->fun_called->window,
                      this->font,
                      this->fun_called->style->
                          fg_gc[GTK_WIDGET_STATE (this->fun_called)],
                      5, i*this->font_height+this->font_ascent,
                      buf);
    }
  }
  return TRUE;
}

static gboolean _11(GtkWidget *_widget, GdkEvent *_event, gui *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    int line;
    sym_info *cur;
    char *name;
    if (this->called == NULL) return TRUE;
    if (type == GDK_MOTION_NOTIFY) {
      line = y / this->font_height;
      if (line < 0 || line >= list_size(this->called)/2) return TRUE;
      if (this->line_called == line) return TRUE;
      this->line_called = line;
      gtk_widget_queue_draw(this->fun_called);
      return TRUE;
    }
    if (type != GDK_BUTTON_PRESS) return TRUE;
    line = y / this->font_height;
    if (line < 0 || line >= list_size(this->called)/2) return TRUE;
    cur = symbols + list_get(this->called, line*2);
    name = symbol_name(list_get(this->called, line*2));
    gtk_entry_set_text(GTK_ENTRY(this->fun_current), dump_symbol(cur, name));
    this->cur = cur;
    this->name = name;

    this->calls = &cur->call;
    this->called = &cur->called_by;
    this->call_width = 1;
    this->called_width = 1;

    gtk_widget_set_size_request(this->fun_call, 200,
                                this->font_height * list_size(this->calls)/2);
    gtk_widget_set_size_request(this->fun_called, 200,
                                this->font_height * list_size(this->called)/2);
    gtk_widget_queue_draw(this->fun_call);
    gtk_widget_queue_draw(this->fun_called);
  }
  return TRUE;
}

/* returns -1 on error, 0 if everything is fine */
int init_gui(gui *this)
{
  GtkWidget *_5;
  GtkWidget *_49;
  GtkWidget *_51;
  GtkWidget *_53;
  GtkWidget *_12;
  GtkWidget *_14;
  GtkWidget *_16;
  GtkWidget *_18;
  GtkWidget *_20;
  GtkWidget *_22;
  GtkWidget *_24;
  GtkWidget *_26;
  GtkWidget *_28;
  GtkWidget *_31;
  GtkWidget *_32;
  GtkWidget *_33;
  GtkWidget *_34;
  GtkWidget *_35;
  GtkWidget *_36;
  GtkWidget *_37;
  GtkWidget *_38;
  GtkWidget *_39;
  GtkWidget *_40;
  GtkWidget *_41;
  GtkWidget *_42;
  GtkWidget *_43;
  GtkWidget *_44;
  GtkWidget *_45;
  GtkWidget *_46;
  GtkWidget *_47;
  GtkWidget *_48;
  GtkWidget *_50;
  GtkWidget *_52;
  GtkWidget *_54;

  {
    alpha_order = sorted_symbols_by_name;
    calls_order = sorted_symbols_by_calls;
    self_order = sorted_symbols_by_self;
    cumul1_order = sorted_symbols_by_cumuled_1;
    cumul2_order = sorted_symbols_by_cumuled_2;

    this->line_fun = 0;
    this->line_call = 0;
    this->line_called = 0;

    this->cur = 0;

    this->pretty_print_width = 64;

    this->order = alpha_order;
    this->font = gdk_font_load("fixed");
    if (!this->font) {
      fprintf(stderr, "error loading font\n");
      exit(1);
    }
    this->font_height = this->font->ascent + this->font->descent + 2;
    this->font_ascent = this->font->ascent;
    if (this->font_height < 10) {
      fprintf(stderr, "WARNING: font_height of 'fixed' = %d, forcing 10\n",
              this->font_height);
      this->font_height = 10;
      this->font_ascent = 10;
    }
    this->calls = 0;
    this->called = 0;
    this->list_width = 1;
    this->call_width = 1;
    this->called_width = 1;
    this->about_displayed = 0;
  }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(this->win, 700, 500);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _5 = gtk_vbox_new(FALSE, 5);
  _49 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_49),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_49),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_49),
      GTK_CORNER_TOP_LEFT);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_49, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_49, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_49, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_49, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_49, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  _51 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_51),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_51),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_51),
      GTK_CORNER_TOP_LEFT);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_51, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_51, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_51, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_51, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_51, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  _53 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_53),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_53),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_53),
      GTK_CORNER_TOP_LEFT);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_53, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_53, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_53, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_53, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_53, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  this->fun_current = gtk_entry_new();
  this->call_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->call_label), "Calls");
  gtk_misc_set_alignment(GTK_MISC(this->call_label), 0.000000, 0.500000);
  this->called_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->called_label), "Called by");
  gtk_misc_set_alignment(GTK_MISC(this->called_label), 0.000000, 0.500000);
  this->call_label_box = gtk_vbox_new(FALSE, 0);
  this->called_label_box = gtk_vbox_new(FALSE, 0);
  this->top_box = gtk_hbox_new(FALSE, 0);
  this->call_box = gtk_vbox_new(FALSE, 0);
  this->call_box_left = gtk_hbox_new(FALSE, 0);
  gtk_widget_set_size_request(this->call_box_left, 100, -1);
  this->call_box_right = gtk_hbox_new(FALSE, 0);
  gtk_widget_set_size_request(this->call_box_right, 100, -1);
  this->all_box = gtk_hbox_new(FALSE, 0);
  this->choice_alpha = gtk_radio_button_new(0);
  _12 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_12), "Alphabetic");
  this->choice_nbcalls = gtk_radio_button_new(0);
  _14 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_14), "Calls");
  this->choice_selftime = gtk_radio_button_new(0);
  _16 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_16), "Self time");
  this->choice_cumul1 = gtk_radio_button_new(0);
  _18 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_18), "Cumulated time 1");
  this->choice_cumul2 = gtk_radio_button_new(0);
  _20 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_20), "Cumulated time 2");
  this->quit_button = gtk_button_new();
  _22 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_22), "Quit");
  this->about_button = gtk_button_new();
  _24 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_24), "About");
  this->help_button = gtk_button_new();
  _26 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_26), "Help");
  this->spacing_box = gtk_vbox_new(FALSE, 0);
  this->button_box = gtk_vbox_new(FALSE, 0);
  this->pretty_print_box = gtk_vbox_new(FALSE, 0);
  this->pp_empty_box = gtk_vbox_new(FALSE, 0);
  gtk_widget_set_size_request(this->pp_empty_box, 1, -1);
  this->pretty_print_button = gtk_toggle_button_new();
  _28 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_28), "Pretty print");
  this->pretty_print_text = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->pretty_print_text),
    "64");
  gtk_widget_set_size_request(this->pretty_print_text, 50, -1);
  _31 = gtk_hbox_new(FALSE, 0);
  _32 = gtk_hbox_new(FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(_32), 5);
  _33 = gtk_vseparator_new();
  _34 = gtk_hbox_new(FALSE, 0);
  _35 = gtk_hbox_new(FALSE, 0);
  _36 = gtk_vbox_new(FALSE, 5);
  _37 = gtk_hbox_new(FALSE, 0);
  _38 = gtk_hpaned_new();
  _39 = gtk_hbox_new(FALSE, 0);
  _40 = gtk_hbox_new(FALSE, 0);
  _41 = gtk_vbox_new(FALSE, 5);
  _42 = gtk_vbox_new(FALSE, 5);
  _43 = gtk_vbox_new(FALSE, 0);
  _44 = gtk_vpaned_new();
  _45 = gtk_vbox_new(FALSE, 0);
  _46 = gtk_vbox_new(FALSE, 0);
  _47 = gtk_hbox_new(TRUE, 0);
  _48 = gtk_hbox_new(FALSE, 5);
  _50 = gtk_viewport_new(0, 0);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(_50),
      GTK_SHADOW_NONE);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_50, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_50, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_50, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_50, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_50, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  this->fun_list = gtk_drawing_area_new();
  gtk_widget_add_events(this->fun_list, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events(this->fun_list, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events(this->fun_list, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events(this->fun_list, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request(this->fun_list, 1, 1);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_list, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_list, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_list, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_list, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_list, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  _52 = gtk_viewport_new(0, 0);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(_52),
      GTK_SHADOW_NONE);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_52, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_52, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_52, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_52, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_52, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  this->fun_call = gtk_drawing_area_new();
  gtk_widget_add_events(this->fun_call, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events(this->fun_call, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events(this->fun_call, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events(this->fun_call, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request(this->fun_call, 1, 1);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_call, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_call, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_call, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_call, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_call, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  _54 = gtk_viewport_new(0, 0);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(_54),
      GTK_SHADOW_NONE);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_54, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_54, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_54, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_54, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(_54, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  this->fun_called = gtk_drawing_area_new();
  gtk_widget_add_events(this->fun_called, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events(this->fun_called, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events(this->fun_called, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events(this->fun_called, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request(this->fun_called, 1, 1);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_called, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_called, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_called, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_called, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg(this->fun_called, GTK_STATE_INSENSITIVE, &_color);
    }
  }

  gtk_container_add(GTK_CONTAINER(this->win), _5);
  gtk_box_pack_start(GTK_BOX(_5), _31, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_5), _32, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_49), _50);
  gtk_container_add(GTK_CONTAINER(_51), _52);
  gtk_container_add(GTK_CONTAINER(_53), _54);
  gtk_box_pack_start(GTK_BOX(this->call_label_box), _34, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->called_label_box), _35, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->top_box), _36, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(this->call_box), _37, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(this->call_box_left), _41, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(this->call_box_right), _42, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(this->all_box), _43, TRUE, TRUE, 0);
  gtk_container_add(GTK_CONTAINER(this->choice_alpha), _12);
  gtk_container_add(GTK_CONTAINER(this->choice_nbcalls), _14);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->choice_nbcalls),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->choice_alpha)));
  gtk_container_add(GTK_CONTAINER(this->choice_selftime), _16);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->choice_selftime),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->choice_alpha)));
  gtk_container_add(GTK_CONTAINER(this->choice_cumul1), _18);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->choice_cumul1),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->choice_alpha)));
  gtk_container_add(GTK_CONTAINER(this->choice_cumul2), _20);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->choice_cumul2),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->choice_alpha)));
  gtk_container_add(GTK_CONTAINER(this->quit_button), _22);
  gtk_container_add(GTK_CONTAINER(this->about_button), _24);
  gtk_container_add(GTK_CONTAINER(this->help_button), _26);
  gtk_box_pack_start(GTK_BOX(this->button_box), _47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->pretty_print_box), _48, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(this->pretty_print_button), _28);
  gtk_box_pack_start(GTK_BOX(_31), this->all_box, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_32), this->choice_alpha, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_32), this->choice_nbcalls, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_32), this->choice_selftime, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_32), this->choice_cumul1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_32), this->choice_cumul2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_32), _33, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_32), this->pretty_print_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_32), this->spacing_box, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_32), this->button_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_34), this->call_label, FALSE, FALSE, 10);
  gtk_box_pack_start(GTK_BOX(_35), this->called_label, FALSE, FALSE, 10);
  gtk_box_pack_start(GTK_BOX(_36), _49, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_36), this->fun_current, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_37), _38, TRUE, TRUE, 0);
  gtk_paned_pack1(GTK_PANED(_38), _39, TRUE, TRUE);
  gtk_paned_pack2(GTK_PANED(_38), _40, TRUE, TRUE);
  gtk_box_pack_start(GTK_BOX(_39), this->call_box_left, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_40), this->call_box_right, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_41), this->call_label_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_41), _51, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_42), this->called_label_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_42), _53, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_43), _44, TRUE, TRUE, 0);
  gtk_paned_pack1(GTK_PANED(_44), _45, TRUE, TRUE);
  gtk_paned_pack2(GTK_PANED(_44), _46, TRUE, TRUE);
  gtk_box_pack_start(GTK_BOX(_45), this->top_box, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_46), this->call_box, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_47), this->help_button, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_47), this->about_button, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_47), this->quit_button, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_48), this->pp_empty_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_48), this->pretty_print_button, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_48), this->pretty_print_text, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_50), this->fun_list);
  gtk_container_add(GTK_CONTAINER(_52), this->fun_call);
  gtk_container_add(GTK_CONTAINER(_54), this->fun_called);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(this->choice_alpha), TRUE);


  this->choice_alpha_clicked = g_signal_connect(this->choice_alpha, "clicked", G_CALLBACK(_13), this);

  this->choice_nbcalls_clicked = g_signal_connect(this->choice_nbcalls, "clicked", G_CALLBACK(_15), this);

  this->choice_selftime_clicked = g_signal_connect(this->choice_selftime, "clicked", G_CALLBACK(_17), this);

  this->choice_cumul1_clicked = g_signal_connect(this->choice_cumul1, "clicked", G_CALLBACK(_19), this);

  this->choice_cumul2_clicked = g_signal_connect(this->choice_cumul2, "clicked", G_CALLBACK(_21), this);

  this->quit_button_clicked = g_signal_connect(this->quit_button, "clicked", G_CALLBACK(_23), this);

  this->about_button_clicked = g_signal_connect(this->about_button, "clicked", G_CALLBACK(_25), this);

  this->help_button_clicked = g_signal_connect(this->help_button, "clicked", G_CALLBACK(_27), this);

  this->pretty_print_button_clicked = g_signal_connect(this->pretty_print_button, "clicked", G_CALLBACK(_29), this);

  this->pretty_print_text_activate = g_signal_connect(this->pretty_print_text, "activate", G_CALLBACK(_30), this);

  this->fun_list_expose = g_signal_connect(this->fun_list, "expose-event", G_CALLBACK(_6), this);
  this->fun_list_pointer_motion = g_signal_connect(this->fun_list, "motion-notify-event", G_CALLBACK(_7), this);
  this->fun_list_pointer_press = g_signal_connect(this->fun_list, "button-press-event", G_CALLBACK(_7), this);
  this->fun_list_pointer_release = g_signal_connect(this->fun_list, "button-release-event", G_CALLBACK(_7), this);

  this->fun_call_expose = g_signal_connect(this->fun_call, "expose-event", G_CALLBACK(_8), this);
  this->fun_call_pointer_motion = g_signal_connect(this->fun_call, "motion-notify-event", G_CALLBACK(_9), this);
  this->fun_call_pointer_press = g_signal_connect(this->fun_call, "button-press-event", G_CALLBACK(_9), this);
  this->fun_call_pointer_release = g_signal_connect(this->fun_call, "button-release-event", G_CALLBACK(_9), this);

  this->fun_called_expose = g_signal_connect(this->fun_called, "expose-event", G_CALLBACK(_10), this);
  this->fun_called_pointer_motion = g_signal_connect(this->fun_called, "motion-notify-event", G_CALLBACK(_11), this);
  this->fun_called_pointer_press = g_signal_connect(this->fun_called, "button-press-event", G_CALLBACK(_11), this);
  this->fun_called_pointer_release = g_signal_connect(this->fun_called, "button-release-event", G_CALLBACK(_11), this);

  {
    PangoColor col;
    GdkColor blue_color;

    g_signal_connect(this->win, "destroy", G_CALLBACK(gtk_main_quit), NULL);
    gtk_widget_set_size_request(this->fun_list, 200,
                                this->font_height * nb_unique_symbols());

    /* create a blue gc */
    /* (if it fails xgprof will not start the GUI */
    if (!pango_color_parse(&col, "#DEF")) goto color_error;
    blue_color.red = col.red;
    blue_color.green = col.green;
    blue_color.blue = col.blue;
    if (!gdk_colormap_alloc_color(gdk_colormap_get_system(),
                                  &blue_color, FALSE, TRUE))
      goto color_error;
    blue_gc = gdk_gc_new(gdk_get_default_root_window());
    gdk_gc_set_foreground(blue_gc, &blue_color);
    gdk_gc_set_fill(blue_gc, GDK_SOLID);
    goto after_color;

color_error:
    fprintf(stderr, "Error allocating colors, no GUI.\n");
    exit(1);

after_color:

  /* this code is ripped from sverb (http://sed.free.fr/sverb) */
  /* let's create the help window */
  /* it is juste hidden/shown on user's request, maybe not very efficient? */
{
  GtkWidget *help_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  GtkWidget *vbox = gtk_vbox_new(FALSE, 5);
  GtkWidget *hbox = gtk_hbox_new(FALSE, 5);
  GtkWidget *close_button = gtk_button_new_with_mnemonic("_Close");
  GtkWidget *scroll_win = gtk_scrolled_window_new(NULL, NULL);
  GtkTextIter iter;
  GtkTextTagTable *table = gtk_text_tag_table_new();
  GtkTextBuffer *buffer = gtk_text_buffer_new(table);
  GtkWidget *t = gtk_text_view_new_with_buffer(buffer);
  {
    /* let's force minimal size of help_window to be 1x1, I don't like to let
     * the user with a too big window if she wants to resize it smaller
     */
    GdkGeometry g;
    g.min_width = g.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(help_window),
                                  help_window, &g, GDK_HINT_MIN_SIZE);
  }
  gtk_window_set_title(GTK_WINDOW(help_window), "XGprof help");
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_win),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_container_add(GTK_CONTAINER(help_window), vbox);
  gtk_box_pack_start(GTK_BOX(vbox), scroll_win, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 5);
  gtk_box_pack_start(GTK_BOX(hbox), close_button, FALSE, FALSE, 5);
  gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(t), GTK_WRAP_WORD);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(t), FALSE);
  gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(t), FALSE);
  gtk_text_view_set_pixels_above_lines(GTK_TEXT_VIEW(t), 5);
  gtk_text_view_set_pixels_below_lines(GTK_TEXT_VIEW(t), 5);
  gtk_text_view_set_left_margin(GTK_TEXT_VIEW(t), 10);
  gtk_text_view_set_right_margin(GTK_TEXT_VIEW(t), 10);
  /* not supported by the gtk on my host... WHY TO PROVIDE THE FILL PARAMETER
   * THEN!!??
  gtk_text_view_set_justification(GTK_TEXT_VIEW(t), GTK_JUSTIFY_FILL);
   */
  gtk_widget_set_size_request(t, 400, 300);
  gtk_container_add(GTK_CONTAINER(scroll_win), t);
  gtk_text_buffer_create_tag(buffer, "b",
      "weight", PANGO_WEIGHT_BOLD,
      0);
  gtk_text_buffer_create_tag(buffer, "p",
      "size", 14 * PANGO_SCALE,
      //"pixels_above_lines", 20,
      0);
  gtk_text_buffer_create_tag(buffer, "h1",
      "justification", GTK_JUSTIFY_CENTER,
      "weight", PANGO_WEIGHT_BOLD,
      "size", 20 * PANGO_SCALE,
      0);
  gtk_text_buffer_create_tag(buffer, "h2",
      "weight", PANGO_WEIGHT_BOLD,
      "size", 18 * PANGO_SCALE,
      0);
  gtk_text_buffer_create_tag(buffer, "h3",
      "weight", PANGO_WEIGHT_BOLD,
      "size", 16 * PANGO_SCALE,
      0);
  gtk_text_buffer_get_iter_at_offset (buffer, &iter, 0);
  #include "help_gui.h"
  this->help_window = help_window;
  this->help_window_shown = 0;
  g_signal_connect(close_button, "clicked",
      G_CALLBACK(toggle_help_callback), this);
  g_signal_connect(help_window, "delete-event",
      G_CALLBACK(delete_help_callback), this);
}
    /* let's get dimensions for the pretty printing */
    {
      int i;
      int lname;
      int maxname = 0;
      int ncalls;
      int maxcalls = 0;
      double tself;
      double maxtself = 0;
      double t1;
      double maxt1 = 0;
      double t2;
      double maxt2 = 0;
      for (i=0; i<=nb_unique_symbols()-1; i++) {
        lname=strlen(symbol_name(this->order[i]));
        if( maxname<lname ) maxname=lname;
        sym_info *cur = symbols + this->order[i];
        ncalls = cur->count;
        if( maxcalls<ncalls ) maxcalls=ncalls;
        tself = cur->internal_time / 100;
        if( maxtself<tself ) maxtself=tself;
        t1 = cur->cumuled_time_1 / 100;
        if( maxt1<t1 ) maxt1=t1;
        t2 = cur->cumuled_time_2 / 100;
        if( maxt2<t2 ) maxt2=t2;
      }
      width_maxname = maxname;
      width_maxcalls = intwidth(maxcalls);
      width_maxtself = floatwidth(maxtself);
      width_maxt1 = floatwidth(maxt1);
      width_maxt2 = floatwidth(maxt2);
    }
  }

  return 0;
}

