#ifndef _SYMLIST_H_
#define _SYMLIST_H_

#include "list.h"

typedef struct {
  list call;
  list called_by;
  int count;
  unsigned long lowpc;
  unsigned long highpc;
  double internal_time; 
  double cumuled_time_1;
  double cumuled_time_2;
  /* tarjan algo stuff (should not be here, but the heck) */
  /* http://www.ics.uci.edu/~eppstein/161/960220.html */
  int visited:1;
  int inT:1;
  int low, dfsnum;
  int scc; /* the strongly connected component the node belongs to */
} sym_info;

extern sym_info *symbols;
extern int *sorted_symbols_by_address;
extern int *sorted_symbols_by_name;
extern int *sorted_symbols_by_calls;
extern int *sorted_symbols_by_self;
extern int *sorted_symbols_by_cumuled_1;
extern int *sorted_symbols_by_cumuled_2;

extern int *sorted_data;

int add_symbol(unsigned long, unsigned long, char *);
int add_null_symbol(void);
int end_add_symbol(void);
int find_symbol(unsigned long);
char *symbol_name(int);
int nb_symbols(void);
int nb_unique_symbols(void);
int sort_symbols(void);

unsigned long get_symbol_lowpc(int);
unsigned long get_symbol_highpc(int);

#endif /* _SYMLIST_H_ */
